import { type Options, type PostgresType } from 'postgres';
import { type MigrationMetadata, type EmigrateStorage, type LoaderPlugin, type Storage, type GenerateMigrationFunction, type GeneratorPlugin, type Awaitable, type MigrationFunction } from '@emigrate/types';
type ConnectionOptions = Options<Record<string, PostgresType>>;
export type PostgresStorageOptions = {
    table?: string;
    /**
     * @see https://github.com/porsager/postgres#connection
     */
    connection: ConnectionOptions | string;
};
export type PostgresLoaderOptions = {
    /**
     * @see https://github.com/porsager/postgres#connection
     */
    connection: ConnectionOptions | string;
};
export declare const createPostgresStorage: ({ table, connection, }: PostgresStorageOptions) => EmigrateStorage;
export declare const createPostgresLoader: ({ connection }: PostgresLoaderOptions) => LoaderPlugin;
export declare const generateMigration: GenerateMigrationFunction;
export declare const initializeStorage: () => Promise<Storage>;
export declare const loadableExtensions: string[];
export declare const loadMigration: (migration: MigrationMetadata) => Awaitable<MigrationFunction>;
declare const defaultExport: EmigrateStorage & LoaderPlugin & GeneratorPlugin;
export default defaultExport;
//# sourceMappingURL=index.d.ts.map